function varargout = EMDiagram(varargin)
% EMDIAGRAM MATLAB code for EMDiagram.fig
%      EMDIAGRAM, by itself, creates a new EMDIAGRAM or raises the existing
%      singleton*.
%
%      H = EMDIAGRAM returns the handle to a new EMDIAGRAM or the handle to
%      the existing singleton*.
%
%      EMDIAGRAM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EMDIAGRAM.M with the given input arguments.
%
%      EMDIAGRAM('Property','Value',...) creates a new EMDIAGRAM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before EMDiagram_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to EMDiagram_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

%   Copyright 2016 Mark J. Verveld
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.

% Last Modified by GUIDE v2.5 01-Mar-2016 13:46:54

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @EMDiagram_OpeningFcn, ...
                   'gui_OutputFcn',  @EMDiagram_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before EMDiagram is made visible.
function EMDiagram_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to EMDiagram (see VARARGIN)

% Choose default command line output for EMDiagram
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

global hft Wlbs LF DI model

load thrustmodelR

hft   = get(handles.s_h,'Value');
Wlbs  = get(handles.s_W,'Value');
LF    = 9.0;
DI    = get(handles.s_di,'Value');
model = TPSmodel;
drawemd([handles.axes1,handles.axes2],LF,Wlbs,hft,DI,model);
% UIWAIT makes EMDiagram wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = EMDiagram_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function s_h_Callback(hObject, eventdata, handles)
% hObject    handle to s_h (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

global hft Wlbs LF DI model

hft = get(hObject,'Value');
set(handles.tb_h,'String',sprintf('%5.0f ',hft))
drawemd([handles.axes1,handles.axes2],LF,Wlbs,hft,DI,model);

% --- Executes during object creation, after setting all properties.
function s_h_CreateFcn(hObject, eventdata, handles)
% hObject    handle to s_h (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function s_W_Callback(hObject, eventdata, handles)
% hObject    handle to s_W (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

global hft Wlbs LF DI model

Wlbs = get(hObject,'Value');
set(handles.tb_W,'String',sprintf('%5.0f ',Wlbs))
drawemd([handles.axes1,handles.axes2],LF,Wlbs,hft,DI,model);


% --- Executes during object creation, after setting all properties.
function s_W_CreateFcn(hObject, eventdata, handles)
% hObject    handle to s_W (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function s_di_Callback(hObject, eventdata, handles)
% hObject    handle to s_di (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

global hft Wlbs LF DI model

DI = get(hObject,'Value');
set(handles.tb_di,'String',sprintf('%3.1f ',DI))
drawemd([handles.axes1,handles.axes2],LF,Wlbs,hft,DI,model);


% --- Executes during object creation, after setting all properties.
function s_di_CreateFcn(hObject, eventdata, handles)
% hObject    handle to s_di (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function tb_h_Callback(hObject, eventdata, handles)
% hObject    handle to tb_h (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of tb_h as text
%        str2double(get(hObject,'String')) returns contents of tb_h as a double
global hft Wlbs LF DI model

hft = str2double(get(hObject,'String'));
minVal = get(handles.s_h,'Min');
maxVal = get(handles.s_h,'Max');
if hft < minVal
    hft = minVal;
    set(hObject,'String',sprintf('%5.0f ',hft))
elseif hft > maxVal
    hft = maxVal;
    set(hObject,'String',sprintf('%5.0f ',hft))
end
set(handles.s_h,'Value',hft)
drawemd([handles.axes1,handles.axes2],LF,Wlbs,hft,DI,model);


% --- Executes during object creation, after setting all properties.
function tb_h_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tb_h (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function tb_W_Callback(hObject, eventdata, handles)
% hObject    handle to tb_W (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of tb_W as text
%        str2double(get(hObject,'String')) returns contents of tb_W as a double
global hft Wlbs LF DI model

Wlbs = str2double(get(hObject,'String'));
minVal = get(handles.s_W,'Min');
maxVal = get(handles.s_W,'Max');
if Wlbs < minVal
    Wlbs = minVal;
    set(hObject,'String',sprintf('%5.0f ',Wlbs))
elseif Wlbs > maxVal
    Wlbs = maxVal;
    set(hObject,'String',sprintf('%5.0f ',Wlbs))
end
set(handles.s_W,'Value',Wlbs)
drawemd([handles.axes1,handles.axes2],LF,Wlbs,hft,DI,model);


% --- Executes during object creation, after setting all properties.
function tb_W_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tb_W (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function tb_di_Callback(hObject, eventdata, handles)
% hObject    handle to tb_di (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of tb_di as text
%        str2double(get(hObject,'String')) returns contents of tb_di as a double
global hft Wlbs LF DI model

DI = str2double(get(hObject,'String'));
minVal = get(handles.s_di,'Min');
maxVal = get(handles.s_di,'Max');
if DI < minVal
    DI = minVal;
    set(hObject,'String',sprintf('%3.1f ',DI))
elseif DI > maxVal
    DI = maxVal;
    set(hObject,'String',sprintf('%3.1f ',DI))
end
set(handles.s_di,'Value',DI)
drawemd([handles.axes1,handles.axes2],LF,Wlbs,hft,DI,model);


% --- Executes during object creation, after setting all properties.
function tb_di_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tb_di (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_print.
function pb_print_Callback(hObject, eventdata, handles)
% hObject    handle to pb_print (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global DI Wlbs hft

% fname = ['EMD_',num2str(LF),'G_',num2str(Wlbs/1000),'klbs_',num2str(hft/1000),'kft.pdf'];
fname = ['EMD_',num2str(hft/1000),'kft_',num2str(Wlbs/1000),'klbs_DI',num2str(DI),'.pdf'];
print(handles.figure1,'-dpdf','-noui',fname)


function [] = drawemd(ax,n1,Wlbs,hft,di,model)
%EMD Energy Maneuverability Diagram
%   Plots a diagram in Vtas vs turn rate, showing a carpet plot of constant
%   instantanious turn radius and load factor curves

% some constants & conversions
R2D = 180/pi;
% D2R = pi/180;
ft2m = 0.3048;
m2ft = 1/ft2m;
% NM2m = 1852.0;
% m2NM = 1/NM2m;
Kts2kmh = 1.852;
% kmh2Kts = 1/Kts2kmh;
Kts2mps = Kts2kmh/3.6;
mps2Kts = 1/Kts2mps;
lbs2kg  = 0.45359237; 
% kg2lbs  = 1/lbs2kg;
% gal2l = 3.785411784;
% l2gal = 1/gal2l;

global S CD0 k

CLmax = 1.213096;       % F15C
S     = 608*ft2m^2;     % F15C
CD0   = 0.023 + di/1e4; % F15C
k     = 0.133;          % F15C

h = hft*ft2m;

[p,rho,~,a,~,g] = atmo_isa(h,0);

R = [1000,1200,1500,2000,3000,4000,5000,6000,8000,10000]*ft2m;
n = [1.1,1.5,(2:floor(n1+1))];

cla(ax(1));cla(ax(2))
axes(ax(1));hold on;grid on
ax(1).XMinorGrid = 'on';
ax(1).YMinorGrid = 'on';
ax(1).Color = 'none';
title(['Energy Maneuverability Diagram ',num2str(hft/1000),' kft, ',num2str(Wlbs/1000),' klbs, DI ',num2str(di)])
xlabel('Calibrated Airspeed [Knots]')
ylabel('turn rate [^\circ/s]')
% constant load factor lines (down to R(1)):
for i_n = 1:length(n)
    Vmin = sqrt(g*R(1)*sqrt(n(i_n)^2 - 1));
    Vmax = sqrt(g*R(end)*sqrt(n(i_n)^2 - 1));
    V = linspace(Vmin,Vmax,40);
    psidot = g*sqrt(n(i_n)^2 - 1)./V;
    plot(TAS2KCAS(V,a,p),psidot*R2D,'--k','LineWidth',0.5)
    textstring = ['n=',num2str(n(i_n)),' '];
    h_text = text(TAS2KCAS(Vmin,a,p),psidot(1)*R2D,textstring);
    h_text.VerticalAlignment = 'middle';
    h_text.HorizontalAlignment = 'right';
    h_text.FontName = 'Times New Roman';
end

% constant R lines (upto n(end)):
for i_R = 1:length(R)
    V = sqrt(g*R(i_R)*sqrt(n([1,end]).^2 - 1));
    psidot = V/R(i_R);
    plot(TAS2KCAS(V,a,p),psidot*R2D,'--k','LineWidth',0.5)
    textstring = ['R=',num2str(R(i_R)*m2ft),' ft'];
    h_text = text(TAS2KCAS(V(end),a,p),psidot(end)*R2D,textstring);
    h_text.VerticalAlignment = 'bottom';
    h_text.HorizontalAlignment = 'left';
    h_text.FontName = 'Times New Roman';
end

% add aircraft maneuver envelope
W = Wlbs*lbs2kg*g;

% Corner velocity
Vas_max = sqrt(2*n1*W/(rho*S*CLmax));
Mas_max = Vas_max/a;
psidot_max = g*sqrt(n1^2 - 1)/Vas_max;
KCAS = M2CAS(Mas_max,p)*mps2Kts;
if verLessThan('matlab','8.4.0')
    textstring = ['  ',num2str(KCAS,3),' KCAS, M ',num2str(Mas_max,'%4.2f'),', \psi^'' ',num2str(psidot_max*R2D,3),'^\circ/s'];
    h_text = text(KCAS,psidot_max*R2D,textstring,'VerticalAlignment','bottom');
    h_text.Interpreter = 'tex';
else
    textstring = ['\quad',num2str(KCAS,3),' KCAS, M ',num2str(Mas_max,'%4.2f'),', $\dot \psi$ $',num2str(psidot_max*R2D,3),'\,^{\circ}$/s'];
    h_text = text(KCAS,psidot_max*R2D,textstring,'VerticalAlignment','bottom');
    h_text.Interpreter = 'latex';
end
h_text.FontName = 'Times New Roman';
h_text.BackgroundColor = [1 1 1];
h_text.Color = [1 0 0];
h_p(2) = plot(KCAS,psidot_max*R2D,'or');

% accelerated stall boundary
psidot = linspace(0.001,psidot_max);
C1 = (g./psidot).^2;
C2 = C1*(rho*S*CLmax/(2*W))^2;
Vas = sqrt((1+sqrt(1+4*C2.*C1))./(2*C2));
h_p(1) = plot(TAS2KCAS(Vas,a,p),psidot*R2D,'-r','LineWidth',1);

% Vmax = sqrt(g*R(end)*sqrt(n1^2 - 1));
Vmin = minMach(h,W,model)*a;
Vmax = maxMach(h,W,model)*a;

% structural boundary
V = linspace(Vas_max,Vmax,50);
psidot = g*sqrt(n1^2 - 1)./V;
V = [V,V(end)+0.1];
psidot = [psidot,0];
plot(TAS2KCAS(V,a,p),psidot*R2D,'-r','LineWidth',1)

% Ps = 0 curve
Ps = 0;
V = linspace(Vmin,Vmax);
M = V/a;
D = thrust(M,h,model) - Ps*W./V;
q = impactpressure(M,p);
n = sqrt((D - q*CD0*S).*q*S/k)/W;
n(n<1) = 1;
psidot = g*sqrt(n.^2 - 1)./V;

plotcolor = [30 126 0]/255;

[pdmax,i_max] = max(psidot);
KCAS = TAS2KCAS(V(i_max),a,p);
M_max = V(i_max)/a;
if verLessThan('matlab','8.4.0')
    textstring = ['  ',num2str(KCAS,3),' KCAS, M ',num2str(M_max,'%4.2f'),', \psi^'' ',num2str(pdmax*R2D,3),'^\circ/s'];
    h_text = text(KCAS,pdmax*R2D,textstring,'VerticalAlignment','bottom');
    h_text.Interpreter = 'tex';
else
    textstring = ['\quad',num2str(KCAS,3),' KCAS, M ',num2str(M_max,'%4.2f'),', $\dot \psi$ $',num2str(pdmax*R2D,3),'\,^{\circ}$/s'];
    h_text = text(KCAS,pdmax*R2D,textstring,'VerticalAlignment','bottom');
    h_text.Interpreter = 'latex';
end
h_text.FontName = 'Times New Roman';
h_text.BackgroundColor = [1 1 1];
h_text.Color = plotcolor;
h_p(3) = plot(TAS2KCAS(V,a,p),psidot*R2D,'-','LineWidth',1,'Color',plotcolor);
h_p(4) = plot(KCAS,pdmax*R2D,'o','Color',plotcolor);

legend(h_p,'maneuver envelope','corner velocity','P_s = 0 curve','max. sustained performance')

ax1_pos = ax(1).Position;
ax1_pos(2) = ax1_pos(2) + 20;
CAS_lim = ax(1).XLim*Kts2mps;
M_Lim = [CAS2M(CAS_lim(1),h),CAS2M(CAS_lim(2),h)];
set(ax(2),'Position',ax1_pos,...
         'XAxisLocation','bottom',...
         'XLim',ax(1).XLim,...
         'YAxisLocation','right',...
         'XColor',[0 0 1],...
         'YColor','none',...
         'Color','none');
MTick = M_Lim(1):0.2:M_Lim(2);
MTickLabel = num2cell(MTick');
CTick = zeros(size(MTick));
for ii = 1:length(MTick)
    CTick(ii) = M2CAS(MTick(ii),p)*mps2Kts;
end
set(ax(2),'XTick',CTick)
set(ax(2),'XTickLabel',MTickLabel)
xlabel(ax(2),'Mach','Color',[0 0 1],'Position',[(ax(2).XLim(2)+10) 0 0],'HorizontalAlignment','left')


function Vcas = TAS2KCAS(Vtas,a,p)

Kts2kmh = 1.852;
Kts2mps = Kts2kmh/3.6;
mps2Kts = 1/Kts2mps;

M = Vtas/a;
Vcas = M2CAS(M,p)*mps2Kts;


function Vcas = M2CAS(M,p)
R      = 287.0531;     % spec. gas constant  [J/kg/K]
T0     = 288.15;
gamma  = 1.4;          % ratio of specific heats
a0     = sqrt(gamma*R*T0);
p0     = 101325.0;

qc = impactpressure(M,p);
Vcas = a0*sqrt(5*((qc/p0 + 1).^(2/7) - 1));


function M = CAS2M(Vcas,h)
R      = 287.0531;     % spec. gas constant  [J/kg/K]
T0     = 288.15;
gamma  = 1.4;          % ratio of specific heats
a0     = sqrt(gamma*R*T0);
p0     = 101325.0;
rho0   = 1.224999;

[p,rho,~,a] = atmo_isa(h,0);

M = sqrt(rho0/rho) * Vcas / a;
err = 2;
while abs(err) > 1
    qc = impactpressure(M,p);
    err = Vcas - a0*sqrt(5*((qc/p0 + 1).^(2/7) - 1));
    M = M + sqrt(rho0/rho) * err / a;
end


function qc = impactpressure(M,p)
gamma  = 1.4;          % ratio of specific heats
gogm1  = gamma/(gamma - 1);

A = zeros(1,length(M));

for ii = 1:length(M)
    if M(ii) < 1
        A(ii) = (1 + (gamma - 1)/2*M(ii)^2)^gogm1;
    else
        % supersonic Rayleigh Pitot tube formula
        A(ii) = ((1 - gamma + 2*gamma*M(ii)^2)/(gamma + 1))*(((gamma + 1)^2 * M(ii)^2)/(4*gamma*M(ii)^2 - 2*(gamma - 1)))^gogm1;
    end
end
qc = p*(A - 1);


function T = thrust(M,h,model)
% lbf2N   = 4.44822161526;
% T     = 23770*2*lbf2N;  % F15C <-- this should be a function of V and h
ft2m = 0.3048;

rowvec = size(M,2) > 1;

xi(:,1) = M(:);
xi(:,2) = ones(numel(M),1)*h/(10000*ft2m);

if all(isfield(model,{'W','A','X','LSfun','beta','Tmin','Tmax'}))   % hybrid model
    T = model.LSfun(xi(:,1),xi(:,2),model.beta,model.Tmin,model.Tmax);
    if isfield(model,'scale')
        xi = xi*diag(model.scale);       
    end
    if size(model.X,1) == 1
        xi = xi(:,1);
    end
    T = T + TPSinterp(model.W,model.A,model.X,xi);
elseif all(isfield(model,{'W','A','X'}))                            % TPS model
    if isfield(model,'scale')
        xi = xi*diag(model.scale);       
    end
    T = TPSinterp(model.W,model.A,model.X,xi);
elseif all(isfield(model,{'LSfun','beta','Tmin','Tmax'}))           % LS model
    T = model.LSfun(xi(:,1),xi(:,2),model.beta,model.Tmin,model.Tmax);
else
    error('Unknown model type.')
end

if rowvec
    T = T';
end


function Mmax = maxMach(h,W,model)

global S CD0 k

% sample M
M = linspace(.1,2.4);
T = thrust(M,h,model);

p = atmo_isa(h,0);
q = impactpressure(M,p);
D = q*CD0*S + k*W^2/S./q;

sFX = sign(T - D);

idx = find(diff(sFX) < 0,1,'last');
if ~isempty(idx)
    % sample [M(idx),M(idx+1)]
    M = linspace(M(idx),M(idx+1),20);
    T = thrust(M,h,model);

    q = impactpressure(M,p);
    D = q*CD0*S + k*W^2/S./q;

    sFX = sign(T - D);

    idx = find(diff(sFX) < 0,1,'last');

    if idx < 20
        Mmax = (M(idx+1) + M(idx))/2;
    else
        Mmax = M(idx);
    end
else
    Mmax = M(end);
end

function Mmin = minMach(h,W,model)

global S CD0 k

% sample M
M = linspace(.1,2.4);
T = thrust(M,h,model);

p = atmo_isa(h,0);
q = impactpressure(M,p);
D = q*CD0*S + k*W^2/S./q;

sFX = sign(T - D);

idx = find(diff(sFX) > 0,1,'first');
if ~isempty(idx)
    % sample [M(idx-1),M(idx+1)]
    if idx == 1
        M = linspace(M(idx),M(idx+1),20);
    elseif idx == 100
        M = linspace(M(idx-1),M(idx),20);
    else
        M = linspace(M(idx-1),M(idx+1),20);
    end
    T = thrust(M,h,model);

    q = impactpressure(M,p);
    D = q*CD0*S + k*W^2/S./q;

    sFX = sign(T - D);

    idx = find(diff(sFX) > 0,1,'first');

    if idx < 20
        Mmin = (M(idx+1) + M(idx))/2;
    else
        Mmin = M(idx);
    end
else
    Mmin = M(1);
end

function [varargout] = atmo_isa(varargin)

h = varargin{1};

% check if input is row vector
sizeh = size(h);
if sizeh(2) > sizeh(1)
    f_rowvec = 1;
else
    f_rowvec = 0;
end

% transform to column vector
h = h(:);

if nargin >= 2
    dT = varargin{2};
else
    dT = 0;
end

% check altitude
if find(h < -5000 | h > 47000)
    error(['Altitude h = ' num2str(h(h < -5000 | h > 47000)) ' m, must be -5000 <= h <= 47000 m.']); 
end

g0          = 9.80665;      % acceleration of gravity (sea level)
%R           = 287.05287;    % spec. gas constant 
R           = 287.0531;     % spec. gas constant  [J/kg/K]
gamma       = 1.4;          % ratio of specific heats
beta        = 1.458e-6;     % constant for calculation mu
S           = 110.4;        % Sutherland's constant

% properties of:  troposphere  stratosphere          mesosphere  
%                                           20km<h<32km  32km<h<47km
href        = [      0.0    ;    11000.0   ;  20000.0   ;  32000.0     ]; % reference altitude   [m] 
Tref        = [    288.15   ;      216.65  ;    216.65  ;    228.65    ]; % temperature at href  [K]
pref        = [ 101325.0    ;    22632.04  ;   5474.878 ;    868.0158  ]; % pressure at href     [Pa]
lambda      = [     -0.0065 ;        0.0   ;      0.001 ;      0.0028  ]; % temperature gradient [K/m]

% properties at sea level
p0          = pref(1);
T0          = Tref(1);
%rho0        = p0/R/T0;

% init outputs
n_h = length(h);

lay = zeros(n_h,1);
p   = zeros(n_h,1);
%T   = zeros(n_h,1);
%a   = zeros(n_h,1);
%mu  = zeros(n_h,1);

re = 6371000.0;
g = g0*(re/(re+h))^2;

%--------------------------------------------------------------------------
% Atmospheric properties according to int. standard atmosphere  
%--------------------------------------------------------------------------

% find corresponding atmospheric layer for altitude h
hbound      = [-5001.0 11000.0 20000.0 32000.0 47000.0];

for i_h = 1:n_h 
    lay(i_h) = find(hbound>=h(i_h), 1 )-1;
end

idx_tropo = find(lay==2);
idx_other = find(lay~=2);

p(idx_tropo) = pref(lay(idx_tropo)).*exp(-g*(h(idx_tropo)-href(lay(idx_tropo)))/R./Tref(lay(idx_tropo)));
p(idx_other) = pref(lay(idx_other)).*(1+lambda(lay(idx_other)).*(h(idx_other)-href(lay(idx_other)))./Tref(lay(idx_other))).^(-g/R./lambda(lay(idx_other)));

T     = Tref(lay)+lambda(lay).*(h-href(lay)) + dT;
rho   = p/R./T;
a     = sqrt(gamma*R.*T);
mu    = beta*T.^1.5./(T+S);

%--------------------------------------------------------------------------
% output
%--------------------------------------------------------------------------

% if input was a row vector, return row vectors as results
if f_rowvec
    p   = transpose(p);
    rho = transpose(rho);
    T   = transpose(T);
    a   = transpose(a);
    mu  = transpose(mu);
end

varargout{1}    = p;
varargout{2}    = rho;
varargout{3}    = T;
varargout{4}    = a;
varargout{5}    = mu;
varargout{6}    = g;
varargout{7}    = R;
varargout{8}    = gamma;
varargout{9}    = beta;
varargout{10}   = S;
% end function atmo_isa
 
function yi = TPSinterp(W,A,X,xi)
% TPSINTERP thin plate spline interpolation
%   Usage: yi = TPSinterp(W,A,X,xi)
%   W   p*n matrix containing part of the TPS
%   A   (m+1)*n matrix containing part of the TPS
%   X   contains p m-dim control points as row vectors (size p*m)
%   xi  contains q m-dim interp. points as row vectors (size q*m)

yi = RBSinterp(W,A,X,xi);

function [yi,DyiDxi] = RBSinterp(W,A,X,xi)
%RBSINTERP radial basis spline interpolation

[p1,m1] = size(X);
[q ,m2] = size(xi);
[p2,n1] = size(W);
[m3,n2] = size(A);
% checks
assert(m1 == m2,'the 2nd dimension of X and xi must match.')
assert(p1 == p2,'the 1st dimension of X and W must match.')
assert(n1 == n2,'the 2nd dimension of W and A must match.')
assert(m1 == (m3-1),'the 1st dimension of A must be 1 larger than the 2nd of X.')

p = p1;
m = m1;

rbfname = 'tps';                  % tps
rbfparam = [];                     % param for RBF, empty when not required

[rbf,DpsiDx] = RBFSelect(rbfname,[m p],rbfparam);

%% dimension check
switch rbfname
    case 'ips'
        if m > 2
            X = X(:,1:2);
            xi = xi(:,1:2);
            m = 2;
            warning('ips is 2D, discarding dimensions > 2.')
        end
    case {'euh','EuclidsHat'}
        if m ~= 3
            warning('Euclid''s Hat is meant to be used with 3 independent dimensions.')
        end
    case {'C0','WendlandC0'}
        if m ~= 3
            warning('Wendland''s C^0 is meant to be used with 3 independent dimensions.')
        end
    case {'C2','WendlandC2'}
        if m ~= 3
            warning('Wendland''s C^2 is meant to be used with 3 independent dimensions.')
        end
end


%% construction
% calculate distance matrix between control points and interpolation points
% Note: pdist2 is not applicable here as there are two different sets of 
% points and the thus the result will in general not be symmetrical

if p*q*m < 1.25e8
    a = reshape(xi,1,q,m);
    b = reshape(X,p,1,m);
    R = sqrt(sum((a(ones(p,1),:,:) - b(:,ones(q,1),:)).^2,3));  % (size p*q)
    clear a b
else            % very large size, preserve memory to speed up
    if q <= p
        R = zeros(p,q);
        for k = 1:q
            R(:,k) = sqrt(sum((xi(k*ones(p,1),:) - X).^2,2));
        end
    else
        R = zeros(q,p);
        for k = 1:p
            R(:,k) = sqrt(sum((X(k*ones(q,1),:) - xi).^2,2));
        end
        R = R';
    end
end

% RBF kernel (size p*q)
psi = rbf(R);
psi(isnan(psi)) = 0;

%% vectorized interpolation
yi = repmat(A(1,:),q,1) + xi*A(2:end,:) + psi'*W;

%% derivative output (dimension m*n*q)
if nargout == 2
    DyiDxi = repmat(A(2:end,:),[1,1,q]);
    for ii = 1:q
        DyiDxi(:,:,ii) = DyiDxi(:,:,ii) + DpsiDx(R(:,ii),X,xi(ii,:))*W;
    end
end
% EOF RBSinterp.m

function [h_fun,h_deriv] = RBFSelect(rbfname,dim,varargin)
% RBFSELECT radial basis function selection

if nargin == 3
    k = varargin{1};
    if isempty(k)
        k = 1;     % default
    end
else
    k = 1;
end

assert(isvector(dim) && numel(dim) == 2,'Second argument must be a 2 element vector.')
m = dim(1);
p = dim(2);

switch rbfname
    case 'tps'
        h_fun   = @(R) (R.^2).*log(R);
        h_deriv = @(R,X,xi) (repmat(xi,p,1) - X)'.*(1 + 2*log(repmat(R,1,m)));
    case 'ips'
        h_fun   = @(R) (R.^2).*log(R);
        h_deriv = @(R,X,xi) (repmat(xi,p,1) - X)'.*(1 + 2*log(repmat(R,1,m)));
    case {'ph','polyharmonic'}
        if mod(k,2) % odd
            h_fun   = @(R) (R.^k);
            h_deriv = @(R,X,xi) k*(repmat(xi,p,1) - X)'.*repmat(R,1,m).^k / repmat(R,1,m).^2;
        else               % even
            h_fun   = @(R) ((R.^k).*log(R));
            h_deriv = @(R,X,xi) ((1 + k*log(repmat(R,1,m))).*(repmat(xi,p,1) - X)'.*repmat(R,1,m).^(k+1))./repmat(R,1,m).^3;
        end
    case {'vol','volume'}
        h_fun   = @(R) R;
        h_deriv = @(R,X,xi) ((repmat(xi,p,1) - X)'./repmat(R,1,m));
    case {'euh','EuclidsHat'}
        sat     = @(R) (R - abs(R - 2*k) + 2*k)/2;                      % saturate R at 2*k
        h_fun   = @(R) pi*( 1/12*sat(R).^3 - k^2*sat(R) + 4/3*k^3 );    % TODO: include threshold to force the value to exactly zero for R >= 2*k
        h_deriv = @(R,X,xi) (pi*(repmat(xi,p,1) - X)'.*(repmat(sat(R),1,m).^2 - 4*k^2)./(4*repmat(sat(R),1,m)));
    case {'C0','WendlandC0'}
        sat     = @(R) (R - abs(R - 1) + 1)/2;                          % saturate R at 1
        h_fun   = @(R) (1 - sat(R)).^2;
        h_deriv = @(R,X,xi) ((repmat(xi,p,1) - X)'.*(2 - 2./repmat(sat(R),1,m)));
    case {'C2','WendlandC2'}
        sat     = @(R) (R - abs(R - 1) + 1)/2;                          % saturate R at 1
        h_fun   = @(R) (4*sat(R) + 1).*(1 - sat(R)).^4;
        h_deriv = @(R,X,xi) 20*(repmat(xi,p,1) - X)'.*(repmat(sat(R),1,m) - 1).^3;
    case {'GF','Gauss'}
        h_fun   = @(R) exp(-(k*R).^2);
        h_deriv = @(R,X,xi) 2*exp(-k^2*repmat(R,1,m).^2).*(X - repmat(xi,p,1))'.*k^2;
    case 'mq'
        h_fun   = @(R) sqrt(1 + (k*R).^2);
        h_deriv = @(R,X,xi) k^2*(repmat(xi,p,1) - X)'./sqrt(k^2*repmat(R,1,m).^2 + 1);
    case 'imq'
        h_fun   = @(R) sqrt(1 + (k*R).^2).^(-1);
        h_deriv = @(R,X,xi) k^2*(X - repmat(xi,p,1))./sqrt((repmat(R,1,m).^2*k^2 + 1).^3);
    case 'iq'
        h_fun   = @(R) (1 + (k*R).^2).^(-1);
        h_deriv = @(R,X,xi) 2*k^2*(X - repmat(xi,p,1))./(repmat(R,1,m).^2*k^2 + 1).^2;
    otherwise
        error('Unknown rbf requested.')
end
